import java.awt.Color;
import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;

/**
 * c[e[up̃_
 * 
 * @author enegate
 */
public class ConceptTreeTableCellRenderer extends DefaultTableCellRenderer {
	
	private static final Color evenColor = new Color(240, 240, 255);
	private static int selectedRow = -1;
	private static int selectedColumn = -1;
	
	public Component getTableCellRendererComponent(
			JTable table,
			Object value,
			boolean isSelected,
			boolean hasFocus,
			int row,
			int column) {
		
		super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
		
		int selectedRow = table.getSelectedRow();
		int selectedColumn = table.getSelectedColumn();
		
		String strValue = (String) value;

		if (isSelected || row == selectedRow) {
			setForeground(table.getForeground());
			setBackground(Color.PINK);
		} else if (strValue != null && strValue.length() > 0 && !strValue.equals("-")) {
			setForeground(table.getForeground());
			setBackground(Color.CYAN);
		} else if (column == selectedColumn || row == selectedRow) {
			setForeground(table.getForeground());
			setBackground(evenColor);
		} else {
			setForeground(table.getForeground());
			setBackground(table.getBackground());
		}
		return (this);
	}
}
